| double modf (val, p)
| double val, *p;
| returns fractional part of val
| stashes integral part through p

.comm	fac,8
.comm	tmpfac,2
.text
.globl	_modf
_modf:
	push	bp
	mov	bp,sp
	push	di
	push	si
| val=4.
| p=12.

	fldd	4(bp)		| get number onto stack
	fldd	4(bp)		| get number on stack again
	fstcw	tmpfac		| get control word
	fwait
	or	tmpfac,#/c00	| changing rounding to truncate
	fldcw	tmpfac
	frndint			| round to integer
	and	tmpfac,#/f3ff	| changing rounding back to nearest
	fldcw	tmpfac
	mov	di,12(bp)	| p
	fstd	(di)		| *p = integer part
	fsub			| subtract to get fraction
	fabs			| return positive fraction
	fstdp	fac		| return fraction in fac
	lea	ax,fac		| return pointer to fraction in ax
	jmp	cret
