|       syscall
|
|       syscall(fcn, subfcn, arg1, arg2, arg3, arg4)
|
|       used by cxenix library routines as a convenient interface


	.globl  _syscall

_syscall:
	mov     bx,sp
	push    si              | save registers
	push    di              |
	mov     di,*12(bx)      | arg 4
	mov     si,*10(bx)      | arg 3
	mov     cx,*8(bx)       | arg 2
	movb    ah,*4(bx)       | subfunction
	movb    al,*2(bx)       | function
	mov     bx,*6(bx)       | arg 1
	calli   @Iscadr         | call XENIX
	jnb     lab1
	mov     _errno,ax       | have error if we return
	mov     ax,#-1
lab1:   pop     di              | restore reg
	pop     si
	ret

