|***    C library -- wait
|
|       pid = wait(0);
|         or,
|       pid = wait(&status);
|
|       pid == -1 if error
|       status indicates fate of process, if given


	.globl	_wait
	.comm	_errno,2
	.wait = 7.

	.text
_wait:
	mov     ax,*.wait
	calli   @Iscadr         | call XENIX
	mov     dx,bx
	jb      wait1           | have error
	mov     bx,sp
	mov     bx,*2(bx)       | (bx) = address for status
	or      bx,bx
	jz      wait2           | if no status address
	mov     (bx),dx         | set return status
	ret

|       error

wait1:  mov     _errno,ax
	mov     ax,#-1
wait2:  ret

	.end
